import { ElementRef, EventEmitter } from '@angular/core';
import { OcDatetime } from './datetime';
/**
 * show a selected date in monthly calendar
 */
export declare class OcDatetimePickerComponent {
    ocDatetime: OcDatetime;
    dateFormat: string;
    dateOnly: boolean;
    timeOnly: boolean;
    selectedDate: Date;
    hour: number;
    lang: string;
    minute: number;
    second: number;
    defaultValue: Date;
    minDate: Date;
    maxDate: Date;
    minHour: number;
    maxHour: number;
    disabledDates: Date[];
    showWeekNumbers: boolean;
    showAmPm: boolean;
    selected$: EventEmitter<any>;
    closing$: EventEmitter<any>;
    el: HTMLElement;
    disabledDatesInTime: number[];
    showYearSelector: boolean;
    private _monthData;
    private timeSuffix;
    constructor(elementRef: ElementRef, ocDatetime: OcDatetime);
    readonly yearsSelectable: number[];
    year: number;
    month: number;
    day: number;
    readonly monthData: any;
    readonly displayYear: string;
    readonly displayMonth: string;
    today: Date;
    ngOnInit(): void;
    isWeekend(dayNum: number, month?: number): boolean;
    selectYear(year: any): void;
    toDate(day: number, month?: number): Date;
    toDateOnly(date: Date): Date;
    selectCurrentTime(): void;
    /**
     * set the hour and minute
     * @param hour {string}
     * @param minute {string}
     */
    selectTime(hour: any, minute: any, second: any): void;
    /**
     * set the selected date and close it when closeOnSelect is true
     * @param date {Date}
     */
    selectDateTime(date?: Date): boolean;
    confirmButtonClick(): void;
    selectDateChange(select: any, type: any): void;
    /**
     * show prev/next month calendar
     */
    updateMonthData(num: number): void;
    isDateDisabled(date: Date): boolean;
    private convertHours;
}
