/**
 * Static variables that you can override
 *   1. days.           default 1,2,....31
 *   2. daysOfWeek,     default Sunday, Monday, .....
 *   3. firstDayOfWeek, default 0 as in Sunday
 *   4. months,         default January, February
 *   5. formatDate(d)   default returns YYYY-MM-DD HH:MM
 *   6. parseDate(str)  default returns date from YYYY-MM-DD HH:MM
 */
export declare class OcDatetime {
    constructor();
    static language: {
        zh: {
            year: string;
            month: string;
            day: string;
            hour: string;
            minute: string;
            second: string;
            locale: {
                date: string;
                time: string;
                year: string;
                month: string;
                day: string;
                hour: string;
                minute: string;
                confirm: string;
                currentTime: string;
            };
            days: number[];
            hours: number[];
            minutes: number[];
            seconds: number[];
            weekends: number[];
            daysOfWeek: {
                fullName: string;
                shortName: string;
            }[];
            firstDayOfWeek: number;
            months: {
                fullName: string;
                shortName: string;
            }[];
        };
        en: {
            year: string;
            month: string;
            day: string;
            hour: string;
            minute: string;
            second: string;
            locale: {
                date: string;
                time: string;
                year: string;
                month: string;
                day: string;
                hour: string;
                minute: string;
                confirm: string;
                currentTime: string;
            };
            days: number[];
            hours: number[];
            minutes: number[];
            seconds: number[];
            weekends: number[];
            daysOfWeek: {
                fullName: string;
                shortName: string;
            }[];
            firstDayOfWeek: number;
            months: {
                fullName: string;
                shortName: string;
            }[];
        };
    };
    currentLang: any;
    static formatDate(d: Date, format?: string, dateOnly?: boolean): string;
    static parseDate(dateStr: string, parseFormat?: string, dateFormat?: string): Date;
    static getWeekNumber(date: any): number;
    private static removeTimezone;
    private static addDSTOffset;
    private static parseFromDefaultFormat;
    getMonthData(year: number, month: number): any;
}
