import { EventEmitter, TemplateRef, ViewContainerRef } from '@angular/core';
import { ControlContainer, FormArray, FormArrayName, FormBuilder, FormGroup, FormGroupDirective } from '@angular/forms';
import { Subject } from 'rxjs';
export declare class ExpandableButtonAdapter {
    addOperations: Subject<{
        formArray: FormArray;
        formGroup: FormGroup;
    }>;
    removeOperations: Subject<{
        formArray: FormArray;
        index: number;
    }>;
}
export declare class ExpandableFormDirective {
    private v;
    private template;
    private expandableButtonAdapter;
    private addSubscription;
    private removeSubscription;
    private valueChangeSubscription;
    _formArrayDirectiveInstance: ControlContainer;
    _context: any;
    addOperationsDone: EventEmitter<{}>;
    removeOperationsDone: EventEmitter<{}>;
    constructor(v: ViewContainerRef, template: TemplateRef<any>, formArrayDirective: ControlContainer, expandableButtonAdapter: ExpandableButtonAdapter);
    readonly _formArrayInstance: FormArray;
    ngOnInit(): void;
    ngOnDestroy(): void;
    _initView(): void;
    update(): void;
    _addView(): void;
    _removeView(index: any): void;
}
export declare class ExpandableButtonAdd {
    private _expandableButtonAdapter;
    private fb;
    _formArray: FormArray;
    private _context;
    expandDefaultValue: any;
    constructor(formArrayName: FormArrayName, _expandableButtonAdapter: ExpandableButtonAdapter, fb: FormBuilder);
    add(): void;
    _createFormGroupItem(): FormGroup;
}
export declare class ExpandableButtonRemove {
    private _expandableButtonAdapter;
    private fb;
    _formArray: FormArray;
    _formArrayItemDirectiveRef: FormGroupDirective;
    private _removable;
    expandDefaultValue: boolean;
    constructor(formArrayName: FormArrayName, formGroupDirective: FormGroupDirective, _expandableButtonAdapter: ExpandableButtonAdapter, fb: FormBuilder);
    remove(): void;
    _removeFormGroupItem(): number;
}
