import { TranslateService } from '@ngx-translate/core';
import { ValidationFn } from './validation-fn-factory';
import { ValidationControl } from './validation-control';
export declare class ValidationControlFactory {
    private transS;
    constructor(transS: TranslateService);
    static validationWithNameWithMsg(validator: ValidationFn, errName: string, errMsg: string): ValidationControl;
    required(): ValidationControl;
    min(min: number): ValidationControl;
    max(max: number): ValidationControl;
    minLength(minLength: number): ValidationControl;
    maxLength(maxLength: number): ValidationControl;
    pattern(pattern: string | RegExp): ValidationControl;
    float(): ValidationControl;
    integer(): ValidationControl;
    port(): ValidationControl;
    name(): ValidationControl;
    ipv4(): ValidationControl;
    label(): ValidationControl;
    env(): ValidationControl;
}
