import { ElementRef } from '@angular/core';
import { AbstractControl, ControlContainer, NgControl } from '@angular/forms';
import { ValidationControls } from './validation-control';
export declare class ValidationDirective {
    private _el;
    formControlRef: AbstractControl;
    formControlNameRef: string;
    validationControls: ValidationControls;
    private _subscription;
    _formControl: AbstractControl;
    _formGroupDirective: ControlContainer;
    constructor(_el: ElementRef, formGroupDirective: ControlContainer);
    ngOnInit(): void;
    _subscribeValueChange(): void;
    _bindValidationToFormControl(): void;
    /**
     * ErrorMessage Show by validator priority.
     * @private
     */
    _createErrorMessage(): void;
    ngOnDestroy(): void;
}
/**
 * Clean all validator when the binded DOM of formControl instance is no longer exist
 * This directive have same life cycle with host element
 */
export declare class ControlCleanerDirective {
    _formGroupDirective: NgControl;
    _formControl: AbstractControl;
    constructor(_formGroupDirective: NgControl);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
