var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, HostBinding, Input } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { OcTableCell } from '../datasource/oc-table-cell.model';
import { isNull, isUndefined } from 'lodash-es';
let OcTableBodyCellComponent = class OcTableBodyCellComponent {
    constructor(translateS) {
        this.translateS = translateS;
        this.context = this;
        this.updateCellValue();
    }
    ngOnChanges(val) {
        this.updateCellValue();
    }
    updateCellValue() {
        if (!this.cell)
            return;
        if (!this.cell.cellTemplate && this.cell.pipe) {
            this.cellValue = this.cell.pipe(this.cell.value);
        }
        else if (!this.cell.cellTemplate && this.cell.datasource.translatePipePrefix) {
            this.translateS.get(this.cell.datasource.translatePipePrefix + '.cellValue.' + this.cell.column.value + '.' + this.cell.value).subscribe(res => {
                this.cellValue = (res === this.cell.datasource.translatePipePrefix + '.cellValue.' + this.cell.column.value + '.' + this.cell.value) ? this.cell.value : res;
            });
        }
        else {
            this.cellValue = this.cell.value;
        }
        // placeholder '-' for none
        if (isUndefined(this.cellValue) || isNull(this.cellValue) || this.cellValue === '' || this.cellValue.length === 0) {
            this.cellValue = '-';
        }
    }
    get width() {
        return this.cell ? this.cell.width - 24 : null;
    }
    get minWidth() {
        return this.cell ? this.cell.minWidth - 24 : null;
    }
    get lineBreak() {
        let whiteSpace = { 'true': 'normal', 'false': 'nowrap' };
        return this.cell ? whiteSpace[this.cell.lineBreak.toString()] : whiteSpace[false.toString()];
    }
};
__decorate([
    Input(),
    __metadata("design:type", OcTableCell)
], OcTableBodyCellComponent.prototype, "cell", void 0);
__decorate([
    HostBinding('style.width.px'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [])
], OcTableBodyCellComponent.prototype, "width", null);
__decorate([
    HostBinding('style.minWidth.px'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [])
], OcTableBodyCellComponent.prototype, "minWidth", null);
__decorate([
    HostBinding('style.white-space'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [])
], OcTableBodyCellComponent.prototype, "lineBreak", null);
OcTableBodyCellComponent = __decorate([
    Component({
        selector: 'oc-table-body-cell',
        template: `
    <div *ngIf = "!cell?.cellTemplate" class = "cell-value" [innerHTML] = "cellValue"></div>

    <div *ngIf = "cell?.cellTemplate" [ngTemplateOutlet] = "cell.cellTemplate" [ngTemplateOutletContext] = "context"></div>
    <div *ngIf = "cell?.cellDetailTemplate" [ngTemplateOutlet] = "cell.cellDetailTemplate" [ngTemplateOutletContext] = "context"></div>
  `,
        styles: [`:host {
  position: relative;
  overflow: visible;
  display: block; }
  :host .cell-value {
    overflow: hidden;
    text-overflow: ellipsis;
    word-wrap: break-word;
    line-height: 1.5;
    padding: 0 3px 0 0; }
  :host .cell-value-overflow {
    display: none;
    background: green;
    position: absolute;
    top: 5px;
    left: 0;
    z-index: 2; }
`]
    }),
    __metadata("design:paramtypes", [TranslateService])
], OcTableBodyCellComponent);
export { OcTableBodyCellComponent };
