import { EventEmitter, SimpleChanges } from '@angular/core';
import { OcTableColumn } from '../datasource/oc-table-column.model';
import { TranslateService } from '@ngx-translate/core';
/**
 * This component is the actual visible columns, can be drag and reorder by user reaction.
 */
export declare class OcTableHeaderComponent {
    translateS: TranslateService;
    columns: OcTableColumn[];
    initialedColumnWidth: number[];
    resizeEnd: EventEmitter<{
        column: OcTableColumn;
        width: number;
    }>;
    reorderEnd: EventEmitter<{
        order: string[];
    }>;
    resortEnd: EventEmitter<{
        column: OcTableColumn;
        sortOrder: string;
    }>;
    placeholderRef: any;
    private internalColumnWidth;
    private isDraggingDivider;
    constructor(translateS: TranslateService);
    toggleSort(column: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    onDividerDragging({ event, model, distance }: {
        event: any;
        model: any;
        distance: any;
    }, i: any): void;
    onDividerDragEnd({ model, distance }: {
        model: any;
        distance: any;
    }, i: any): void;
    private relativeDistanceArray;
    private insertBeforeIndex;
    onPlaceholderDragStart({ event, element, model, distance }: {
        event: any;
        element: any;
        model: any;
        distance: any;
    }, i: any): void;
    onPlaceholderDragging({ event, element, model, distance }: {
        event: any;
        element: any;
        model: any;
        distance: any;
    }, i: any): void;
    onPlaceholderDragEnd({ event, element, model, distance }: {
        event: any;
        element: any;
        model: any;
        distance: any;
    }, i: any): void;
    private calculateInsertBeforeIndex;
}
