import { OcTableColumn } from './oc-table-column.model';
import { OcTableDataSource } from './table-datasource.model';
import { TemplateRef } from '@angular/core';
import { OcTableRow } from './oc-table-row.model';
import { OcPipeTransformFn } from '../oc-table.interface';
/**
 * The table cell, withe feature of dynamic template & pipes.
 *
 * @property value: the value of cell, can also include method for cell-template call,
 *                  see examples: examples/inline-template-table-example.component.ts
 * @property cellTemplate: the view template of cell
 *                         see examples: examples/inline-template-table-example.component.ts
 * @property row:
 * @property column:
 * @property datasource:
 * @property pipeName: pipe name for pipe applied to text in cell. note that the pipe name must
 *                     exist in OcPipes. see examples: examples/pipes-table-example.component.ts
 */
export declare class OcTableCell {
    value: string | number | boolean | Object;
    cellTemplate?: TemplateRef<any>;
    cellDetailTemplate?: TemplateRef<any>;
    row: OcTableRow;
    column: OcTableColumn;
    datasource: OcTableDataSource;
    constructor(value: string | number | boolean | Object, cellTemplate?: TemplateRef<any>, cellDetailTemplate?: TemplateRef<any>);
    readonly width: number;
    readonly minWidth: number;
    readonly lineBreak: boolean;
    readonly pipe: OcPipeTransformFn;
}
