/**
 * The table cell, withe feature of dynamic template & pipes.
 *
 * @property value: the value of cell, can also include method for cell-template call,
 *                  see examples: examples/inline-template-table-example.component.ts
 * @property cellTemplate: the view template of cell
 *                         see examples: examples/inline-template-table-example.component.ts
 * @property row:
 * @property column:
 * @property datasource:
 * @property pipeName: pipe name for pipe applied to text in cell. note that the pipe name must
 *                     exist in OcPipes. see examples: examples/pipes-table-example.component.ts
 */
export class OcTableCell {
    constructor(value, cellTemplate, cellDetailTemplate) {
        this.value = value;
        this.cellTemplate = cellTemplate;
        this.cellDetailTemplate = cellDetailTemplate;
    }
    get width() {
        if (!this.datasource || !this.column) {
            return null;
        }
        return this.column.width;
    }
    get minWidth() {
        if (!this.datasource || !this.column) {
            return null;
        }
        return this.width || this.column.minWidth;
    }
    get lineBreak() {
        if (!this.datasource || !this.column) {
            return null;
        }
        return this.column.lineBreak;
    }
    get pipe() {
        if (!this.datasource || !this.column) {
            return null;
        }
        return this.column.pipe;
    }
}
