/** Table header
 */
export class OcTableColumn {
    // TODO: isSortable and is no longer needed
    constructor(value, isSortable = true, compareFunction, isNumeric = false) {
        this.value = value;
        this.compareFunction = compareFunction;
        this.isNumeric = isNumeric;
        this._lineBreak = false;
        this._hoverSorter = false;
        this._isSortable = isSortable;
    }
    // support px value only
    get width() {
        // use savedWidth First
        if (this._runtimeWidth) {
            return this._runtimeWidth;
        }
        if (this.config) {
            return this.config.width;
        }
        return null;
    }
    set width(val) {
        this._runtimeWidth = val;
    }
    get minWidth() {
        if (!!this.config) {
            return this.width || this.config.minWidth;
        }
        else {
            return null;
        }
    }
    get lineBreak() {
        if (!!this.config) {
            if (this.config.lineBreak) {
                return this.config.lineBreak;
            }
            else {
                return this._lineBreak;
            }
        }
        else {
            return null;
        }
    }
    get isSortable() {
        if (!!this.config && this.config.hasOwnProperty('sortable')) {
            return this.config.sortable;
        }
        else {
            return this._isSortable;
        }
    }
    set isSortable(val) {
        this._isSortable = val;
    }
    get hoverSorter() {
        return this._hoverSorter;
    }
    set hoverSorter(value) {
        this._hoverSorter = value;
    }
    get sortOrder() {
        return this._sortOrder;
    }
    set sortOrder(value) {
        this._sortOrder = value;
    }
}
