import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter } from '@angular/core';
/**
 * Draggable Directive for Angular2
 *
 * Inspiration:
 *   https://github.com/AngularClass/angular2-examples/blob/master/rx-draggable/directives/draggable.ts
 *   http://stackoverflow.com/questions/35662530/how-to-implement-drag-and-drop-in-angular2
 */
export declare class DraggableDirective {
    model: any;
    duration: number;
    dragStart: EventEmitter<any>;
    dragging: EventEmitter<any>;
    dragEnd: EventEmitter<any>;
    longPressStart: EventEmitter<any>;
    longPressing: EventEmitter<any>;
    longPressEnd: EventEmitter<any>;
    dragEventTarget: any;
    pressing: boolean;
    isLongPressing: boolean;
    timeout: any;
    mouseX: number;
    mouseY: number;
    element: ElementRef;
    isDragging: boolean;
    distance: number;
    subscription: Subscription;
    constructor(element: ElementRef);
    readonly press: boolean;
    readonly isLongPress: boolean;
    readonly draggable: boolean;
    onMouseDown(event: MouseEvent): void;
    onMouseMove(event: MouseEvent): void;
    loop(event: Event): void;
    endPress(): void;
    onMouseup(): void;
    onDragMouseup(event: MouseEvent): void;
    onDragMousedown(event: MouseEvent): void;
    onDragMove(event: MouseEvent, mouseDownPos: {
        x: number;
    }): void;
    ngOnDestroy(): void;
    private _destroySubscription;
}
