import { Observable, Subscription } from 'rxjs';
import { AfterViewInit, ChangeDetectorRef, EventEmitter, SimpleChanges } from '@angular/core';
import { OcTableDataSource, PagerState, SorterState } from './datasource/table-datasource.model';
import { OcTableCell } from './datasource/oc-table-cell.model';
import { OcTableRow } from './datasource/oc-table-row.model';
import { OcTableConfig, OcTableDropdownItem, OcTableFloatingButton } from './oc-table.interface';
import { TranslateService } from '@ngx-translate/core';
import { MatTabGroup } from '@angular/material';
/**
 * How to Use:
 * 1. Do not use data with dataSource together
 *
 */
export declare class OcTableComponent implements AfterViewInit {
    private cdr;
    translateS: TranslateService;
    /**
     * @Internal
     */
    datasource: OcTableDataSource;
    data: any;
    config: OcTableConfig;
    selectCell: EventEmitter<{
        event: MouseEvent;
        cell: OcTableCell;
    }>;
    dbClickCell: EventEmitter<{
        event: MouseEvent;
        cell: OcTableCell;
    }>;
    pagerStateChange: EventEmitter<PagerState>;
    sorterStateChange: EventEmitter<SorterState>;
    deleteCell: EventEmitter<OcTableCell>;
    editCell: EventEmitter<OcTableCell>;
    clickDropdownItem: EventEmitter<{
        dropdownItem: OcTableDropdownItem;
        row: OcTableRow;
    }>;
    clickFloatingButton: EventEmitter<{
        floatingButton: OcTableFloatingButton;
        row: OcTableRow;
    }>;
    /**
     * @deprecated
     */
    onEditCell: EventEmitter<OcTableCell>;
    /**
     * @deprecated
     */
    onDeleteCell: EventEmitter<OcTableCell>;
    /**
     * @deprecated
     */
    onClickDropdownItem: EventEmitter<{
        dropdownItem: OcTableDropdownItem;
        row: OcTableRow;
    }>;
    containerRef: any;
    placeholderRef: any;
    tableRows: any[];
    actionSheets: any;
    showMaskFront: boolean;
    showMaskEnd: boolean;
    initialedColumnWidth: any[];
    tableScrollWidth: number;
    isLoading: boolean;
    subscription: Subscription;
    reload(): void;
    showLoadingBar(): void;
    hideLoadingBar(): void;
    constructor(cdr: ChangeDetectorRef, translateS: TranslateService, tab: MatTabGroup);
    private refreshColumnsWidth;
    private adjustPlaceHolderPosition;
    private adjustHeightForActionSheet;
    isFireFox(): boolean;
    isIE(): number | false;
    isLastCell(cell: OcTableCell): boolean;
    canEditConfigWrapper(row: OcTableRow): boolean | Observable<boolean>;
    canDeleteConfigWrapper(row: OcTableRow): boolean | Observable<boolean>;
    floatingButtonVisibleWrapper(row: OcTableRow, button: OcTableFloatingButton): boolean | Observable<boolean>;
    private judgeVisibleFull;
    private setConfigDefault;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    OnEdit(cell: any): void;
    OnDelete(cell: any): void;
    OnClickDropdownItem(dropdownItem: any, row: any): void;
    onClickFloatingButton(button: any, row: any): void;
    onCellSelect(evt: any): void;
    onCellDbClick(evt: any): void;
    onScroll(): void;
    onMouseOverOnRow(): void;
    onResizeEnd({ column, width }: {
        column: any;
        width: any;
    }): void;
    onReorderEnd({ order }: {
        order: any;
    }): void;
    onResortEnd({ column, sortOrder }: {
        column: any;
        sortOrder: any;
    }): void;
}
