var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { DatePipe } from '@angular/common';
import { Injectable } from '@angular/core';
let OcTablePipeFactory = class OcTablePipeFactory {
    constructor(datePipe) {
        this.datePipe = datePipe;
    }
    /**
     *  | Component | Symbol | Narrow | Short Form   | Long Form         | Numeric   | 2-digit   |
     *  |-----------|:------:|--------|--------------|-------------------|-----------|-----------|
     *  | era       |   G    | G (A)  | GGG (AD)     | GGGG (Anno Domini)| -         | -         |
     *  | year      |   y    | -      | -            | -                 | y (2015)  | yy (15)   |
     *  | month     |   M    | L (S)  | MMM (Sep)    | MMMM (September)  | M (9)     | MM (09)   |
     *  | day       |   d    | -      | -            | -                 | d (3)     | dd (03)   |
     *  | weekday   |   E    | E (S)  | EEE (Sun)    | EEEE (Sunday)     | -         | -         |
     *  | hour      |   j    | -      | -            | -                 | j (13)    | jj (13)   |
     *  | hour12    |   h    | -      | -            | -                 | h (1 PM)  | hh (01 PM)|
     *  | hour24    |   H    | -      | -            | -                 | H (13)    | HH (13)   |
     *  | minute    |   m    | -      | -            | -                 | m (5)     | mm (05)   |
     *  | second    |   s    | -      | -            | -                 | s (9)     | ss (09)   |
     *  | timezone  |   z    | -      | -            | z (Pacific Standard Time)| -  | -         |
     *  | timezone  |   Z    | -      | Z (GMT-8:00) | -                 | -         | -         |
     *  | timezone  |   a    | -      | a (PM)       | -                 | -         | -         |
     *
     */
    date(format) {
        return (value) => {
            return this.datePipe.transform(value, format);
        };
    }
    ageMs(lang) {
        return (str) => {
            let unitMap = {
                'en': {
                    'ms': 'ms',
                    's': 's',
                    'm': 'm',
                    'h': 'h',
                    'd': 'd'
                },
                'zh': {
                    'ms': '毫秒',
                    's': '秒',
                    'm': '分',
                    'h': '小时',
                    'd': '天'
                }
            };
            if (!str || str === '' || str.length === 0) {
                return null;
            }
            let ret = Math.floor(parseInt(str));
            if (ret <= 0) {
                return null;
            }
            else if (ret < 1000) {
                return ret + unitMap[lang]['ms'];
            }
            else if (ret < 60 * 1000) {
                return Math.floor(ret / 1000) + unitMap[lang]['s'];
            }
            else if (ret < 60 * 60 * 1000) {
                return Math.floor(ret / 1000 / 60) + unitMap[lang]['m'];
            }
            else if (ret < 60 * 60 * 24 * 1000) {
                return Math.floor(ret / 1000 / 60 / 60) + unitMap[lang]['h'];
            }
            else {
                return Math.floor(ret / 1000 / 60 / 60 / 24) + unitMap[lang]['d'];
            }
        };
    }
    keyValue() {
        return (obj) => {
            if (!obj || Object.keys(obj).length === 0)
                return null;
            let res = '';
            for (let key in obj) {
                res = res.concat([key, obj[key]].join(': '));
                res = res.concat('<br>');
            }
            return res;
        };
    }
    size(lang) {
        return (value) => {
            let unitMap = {
                'en': {
                    'B': 'B',
                    'KB': 'KiB',
                    'MB': 'MiB',
                    'GB': 'GiB',
                    'TB': 'TiB',
                },
                'zh': {
                    'B': '字节',
                    'KB': '千字节',
                    'MB': '兆字节',
                    'GB': '千兆字节',
                    'TB': '吉字节',
                }
            };
            let ret = Math.floor(parseInt(value));
            if (ret < 0) {
                return null;
            }
            else if (ret < 1024) {
                return ret + unitMap[lang]['B'];
            }
            else if (ret < 1024 * 1024) {
                return Math.floor(ret / 1024) + unitMap[lang]['KB'];
            }
            else if (ret < 1024 * 1024 * 1024) {
                return Math.floor(ret / 1024 / 1024) + unitMap[lang]['MB'];
            }
            else if (ret < 1024 * 1024 * 1024 * 1024) {
                return Math.floor(ret / 1024 / 1024 / 1024) + unitMap[lang]['GB'];
            }
            else {
                return Math.floor(ret / 1024 / 1024 / 1024 / 1024) + unitMap[lang]['TB'];
            }
        };
    }
};
OcTablePipeFactory = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [DatePipe])
], OcTablePipeFactory);
export { OcTablePipeFactory };
